program textureextract;

uses
crt;

type
string8 = string [9];
bitmaptype = array [0.. (256*128)] of byte;

const
c = chr (205);

{
Just some BMP notes, this is a work in progress, please ignore!

0000-0015 66 77 54 68 0 0 0 0 0 0 54 4 0 0 40 0
0016-0031 0 0 X:Longint Y:Longint 1 0 color depth bit (8) 0 0 0
              (128: 80 00 00 00)
0032-0047 0 0 0 64 0 0 0 0 0 0 0 0 0 0 0 1
0048-     0 0 0 1 0 0

0054-   Start of palette: 4 bytes per color: Red, Green, Blue, Unused (00)
}

var
bitmap : bitmaptype;
indfil : file of byte;
bmpfil : file of byte;
palfil : text;
Paletteoffset : array [1..8] of longint;
Tmpval, Textureindex, paletteentry, multiplier, a,b,d,e : byte;
palettehistory : string [8];
searchstr, searchstr2 : string;
bmpfilnavn, tmpstr : string;
redst, greenst, bluest : string[8];
bmp2x, bmp2y, choice, red, green, blue : byte;
tmpstr2 : string;
x,y,bmpx,bmpy,bitmaplen, totalbitmaplen : word;
BitmapStartPos, position : Longint;
int : integer;
ch : char;
float : real;

Function StrSearch (var Searchstr : string):boolean;

begin
{Searches through the file for the specified string}
StrSearch := false;
b:=1;
while (eof (indfil) = false) and (b <> length(searchstr)+1) do
      begin
      read (indfil, a);
      if chr(a) = searchstr [b] then inc (b)
      else b := 1;
      end;
if b = length(searchstr)+1 then StrSearch := true;
end;

{For a little faster texture search!}
Function TexSearch (var searchstr : string) : Boolean;
var
streng : string;
offset : word;

begin
TexSearch := FALSE;
writeln ('File position: ',filepos (indfil));
repeat
streng := chr ($14)+chr(0) + chr(0)+chr(0) + chr(0)+chr(0)+
       chr(0)+chr(0) + chr(0)+chr(0) + chr(0)+chr(0) +chr(1);

if strsearch (streng) = FALSE then exit;

seek (indfil, filepos (indfil) + 7); {Jump to Tex info}

streng := '';
for a:= 1 to 8 do
    begin
    read (indfil, b);
    streng := streng + chr (b);
    end;
seek (indfil, filepos (indfil) + 3); {Jump to palette info}
read (indfil, b);
{check for and possibly add this palette info code to the palette history}
if pos (chr(b), palettehistory) = 0 then palettehistory := palettehistory + chr(b);

if streng = searchstr then
   begin
   TexSearch := TRUE ;
   paletteentry := pos (chr(b), palettehistory);
   writeln ('Found texture "',searchstr,'"',' (offset:', filepos (indfil), ')');
   exit;
   end;


{Big Jump};
seek (indfil, filepos (indfil) + 9);
read (indfil, a);
read (indfil, b);
offset := a+(b*256);
seek (indfil, filepos (indfil) + offset);
until eof (indfil)
end;

Function SeekPalette:boolean;

var
count : byte;

begin
writeln ('Searching for palette...');
count := 0;
SeekPalette := FALSE;
if paletteentry = 0 then exit;
reset (indfil);
while count <> paletteentry do
      begin
      searchstr := c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c
                   +c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c
                   +c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c+c;
      if StrSearch (searchstr) then seek (indfil, filepos (indfil) - 54 + (4096))
      else exit;
      inc (count);
      end;
SeekPalette := TRUE;
end;

procedure ExtractPalette;

begin

   writeln ('Extracting palette #8...');
   seek (indfil, filepos (indfil) + (8 * 512));
   {Write palette}
   for d:= 0 to 255 do
     begin
     read (indfil, a);
     b:=0;          {used 5-6-5 B,G,R win95 bit pattern  for 16 bitmaps}
     if a >= 128 then  begin a:=a-128; b:=b+4;end;
     if a >= 64 then  begin a:=a-64;b:=b+2;end;
     if a >= 32 then  begin a:=a-32;b:=b+1;end;
     Blue:=a*8;          {blue}
     read (indfil, a);
     e:=a;
     if a >=128 then  a:=a-128;
     if a >=64 then  a:=a-64;
     if a >=32 then  a:=a-32;
     if a >=16 then  a:=a-16;
     if a >=8 then  a:=a-8;
     A:=a shl(3);
     a:=a+b;
     e:=e shr(3);
     green:=a*4;      {green}
     red:=e*8;      {red}
     write (bmpfil, blue);
     write (bmpfil, green);
     write (bmpfil, red);
     a:=0;
     write (bmpfil, a);
     end;
end;

Procedure InsertTexture;
begin
   if paramstr (4)  <> '' then tmpstr2 := paramstr (4)
   else
       begin
       write ('Specify BMP file to insert: ');
       readln (tmpstr2);
       end;
   assign (bmpfil, tmpstr2);
   reset (bmpfil);
   if paramstr (3)  <> '' then searchstr := paramstr (3)
   else
       begin
       write ('Texture to replace (eg. Tex00001)?:');
       readln (searchstr);
       end;
   write ('Searching for texture "',searchstr,'"...');
   reset (indfil);
   if TexSearch (searchstr) then
     begin
     writeln ('Found texture... (offset:', filepos (indfil), ')');
     seek (indfil, filepos (indfil) - 12 + 21);
     read (indfil, b);
     read (indfil, a);
     Totalbitmaplen := b + (a*256);
     seek (indfil, filepos (indfil) + 2);
     read (indfil, b);
     read (indfil, a);
     x := b + (a*256);
     seek (indfil, filepos (indfil) + 2);
     read (indfil, b);
     read (indfil, a);
     y := b + (a*256);
     seek (bmpfil, 18);
     read (bmpfil, b);
     read (bmpfil, a);
     bmpx := b + (a*256);
     if x <> bmpx then begin writeln ('Invalid BMP width! - ',bmpx); halt; end;
     seek (bmpfil, 22);
     read (bmpfil, b);
     read (bmpfil, a);
     bmpy := b + (a*256);
     if y <> bmpy then begin writeln ('Invalid BMP height!'); halt; end;
     seek (bmpfil, 1078);
     writeln ('Inserting texture scale 1 to 1...');
     bitmapstartpos := filepos (indfil) + 2;
     position := filepos (indfil) + 3 + (x*y);

     {Store the last byte, since it is sometimes overwritten by this procedure}
     seek (indfil, BitMapStartPos + TotalBitMapLen);
     read (indfil, tmpval);
     for bitmaplen := 0 to (x * y)-1 do
         begin
         seek (indfil, position - bitmaplen);
         read (bmpfil, d);
         write (indfil, d);
         bitmap [((x*y)-bitmaplen)] := d;
         end;


     {The texture continues scaling down until 8*4 (32 bytes)}
     position := filepos (indfil) + (bmp2x*bmp2y) + (x*y);
     seek (indfil, position-2);
     multiplier := 1;
     {while bmpx div multiplier > 8 do}
     while filepos (indfil) < TotalBitmapLen+BitMapStartPos do
     begin
     multiplier := multiplier * 2;
     writeln ('Inserting texture scale 1 to ',multiplier,' ...');
       for y := 1 to bmpy div multiplier do
       begin
          for x := 1 to bmpx div multiplier do
          begin
          write (indfil, bitmap [((((y-1)*multiplier)*bmpx)+(x*multiplier))]);
          end;
       end;
     end;
     seek (indfil, BitMapStartPos + TotalBitMapLen);
     write (indfil, tmpval);
    end;


     close (indfil);
     close (bmpfil);
     writeln ('Done!');
   halt;
end;

procedure Extract2PAL;
begin
   write ('which palette-set do you wish to extract (starting from set 1)?');
   readln (paletteentry);
   write ('Give filename without EXT (file max 6 letters) for palette files: ');
   readln (tmpstr2);
   if seekpalette = FALSE then
      begin
      writeln ('Palette-set #',paletteentry,' do not exist in OPT file.');
      halt;
      end;
   seek (indfil, filepos (indfil) - 8 + (4096));
   for e:= 1 to 16 do
       begin
       str (e, tmpstr);
       assign (palfil, tmpstr2+tmpstr+'.pal');
       rewrite (palfil);
       writeln (palfil, 'JASC-PAL');
       writeln (palfil, '0100');
       writeln (palfil, '256');
       for d:= 0 to 255 do
           begin
           read (indfil, a);
           if a >= 128 then a:=a-128;
           if a >= 64 then a:=a-64;
           if a >= 32 then a:=a-32;
           str ((a*255) div 31, bluest);
           read (indfil, a);
           b:=0;
           if a >= 128 then begin a := a - 128; b := b + 8;end;
           if a >= 64 then begin a := a - 64; b := b + 4;end;
           if a >= 32 then begin a := a - 32; b := b + 2;end;
           if a >= 16 then begin a := a - 16; b := b + 1;end;
           if a >= 8 then begin a := a - 8; end;
           str ((a*255) div 7, greenst);
           str ((b * 255) div 15, redst);
           writeln (palfil, redst+' '+greenst+' '+bluest);
           end;
       close (palfil);
       end;
end;

procedure ExtractTexture;
begin
       {This is just a BMP header!}
       tmpstr2 := chr (66)+chr(77)+chr(54)+chr(68)+chr(0)+chr(0)+chr(0)+
        chr(0)+chr(0)+chr(0)+chr(54)+chr(4)+chr(0)+chr(0)+
        chr(40)+chr(0)+chr(0)+chr(0)+chr(1)+chr(0)+chr(0)+
        chr(0)+chr(1)+chr(0)+chr(0)+chr(0)+chr(1)+chr(0)+chr(8)+
        chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(64)+chr(0)+
        chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+
        chr(0)+chr(0)+chr(1)+
        chr(0)+chr(0)+chr(0)+chr(1)+chr(0)+chr(0);

       for d:= 1 to length (tmpstr2) do
           begin
           ch := tmpstr2 [d];
           a := ord (ch);
           write (bmpfil, a);
           end;

       reset (indfil);
       writeln ('Searching for texture...');
       Palettehistory := '';
       if TexSearch (searchstr2) then
          begin
          writeln ('Texture uses palette-set #', paletteentry,'  extracting... ');
          {Store texture position, we're going to jump around the OPT now}
          position := filepos (indfil) - 12 + 25;
          {Find palette}
          SeekPalette;
          ExtractPalette;

          {Return to stored position of the Texture}
          seek (indfil, position);
          read (indfil, b);
          read (indfil, a);
          x := b + (a*256);
          writeln ('width: ',x);
          seek (bmpfil, 18);
          write (bmpfil, b);
          write (bmpfil, a);

          seek (indfil, filepos (indfil) + 2);
          read (indfil, b);
          read (indfil, a);
          y := b + (a*256);
          writeln ('Height: ',y);
          seek (bmpfil, 22);
          write (bmpfil, b);
          write (bmpfil, a);

          seek (bmpfil, 1078);

          position := filepos (indfil) + 3 + (x*y);
          for bitmaplen := 0 to x * y do
              begin
              seek (indfil, position - bitmaplen);
              read (indfil, d);
              write (bmpfil, d);
              end;


          close (indfil);
          close (bmpfil);
          writeln ('Done.');
          halt;
          end;
end;


begin
clrscr;
writeln;
writeln ('OPT Texture extractor by Michael Andersen (build 5)');
writeln ('Syntax:');
writeln ('extract [optfile] [menu choice 1-4] [Tex##### header] [Output name]');
writeln;

if paramstr(1) <> '' then tmpstr2 := paramstr (1)
else
begin
write ('Specify OPT file for processing: ');
readln (tmpstr2);
end;
assign (indfil, tmpstr2);
reset (indfil);
writeln ('processing: ',tmpstr2);

{Analyzing OPT file}




if paramstr (2) <> '' then
   begin
   val (paramstr(2), choice, int);
   end
   else
   begin
   writeln ('Choose:');
   writeln ('Choose: (1) Extract all palettes to JASC-PAL files');
   writeln ('Choose: (2) Extract texture w/palette #8 in BMP file');
   writeln ('Choose: (3) Insert BMP texture');
   writeln ('Choose: (4) Extract all textures w/palette #8');
   write (': ');
{

write ('Choose: (4) Insert JASC-palettes');
write ('Choose: (5) List textures');
}
   readln (choice);
   end;

if choice = 3 then InsertTexture
else if choice = 2 then
   begin

   if paramstr (3)  <> '' then searchstr2:=paramstr(3)
   else
       begin
       write ('Texture to extract (eg. Tex00001)?:');
       readln (searchstr2);
       end;
   if paramstr (4)  <> '' then tmpstr2:=paramstr(4)
   else
       begin
       write ('Specify BMP filename to be created: ');
       readln (tmpstr2);
       end;
   assign (bmpfil,tmpstr2);
   rewrite (bmpfil);
   ExtractTexture;
   end
else if choice = 4 then
   begin
   if paramstr (3)  <> '' then tmpstr2:=paramstr(3)
   else
       begin
       write ('Specify output files to be created (Max 6 letters in filename): ');
       readln (bmpfilnavn);
       end;
   reset (indfil);
   Palettehistory := '';

   textureindex := 0;
   repeat
   clrscr;
   gotoXY (0,10);
   writeln;
   writeln ('OPT Texture extractor by Michael Andersen (build 4)');
   writeln ('Syntax:');
   writeln ('extract [optfile] [menu choice 1-4] [Tex##### header] [Output name]');
   writeln;
   writeln ('Extracting all textures');
   writeln ('Progress: ', (filepos (indfil) / filesize(indfil)) * 100:2:1,'%' );
   writeln;

   str (Textureindex, tmpstr);
   assign (bmpfil,bmpfilnavn+tmpstr+'.bmp');
   rewrite (bmpfil);
       {This is just a BMP header!}
       tmpstr2 := chr (66)+chr(77)+chr(54)+chr(68)+chr(0)+chr(0)+chr(0)+
        chr(0)+chr(0)+chr(0)+chr(54)+chr(4)+chr(0)+chr(0)+
        chr(40)+chr(0)+chr(0)+chr(0)+chr(1)+chr(0)+chr(0)+
        chr(0)+chr(1)+chr(0)+chr(0)+chr(0)+chr(1)+chr(0)+chr(8)+
        chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(64)+chr(0)+
        chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+
        chr(0)+chr(0)+chr(1)+
        chr(0)+chr(0)+chr(0)+chr(1)+chr(0)+chr(0);
       for d:= 1 to length (tmpstr2) do
           begin
           ch := tmpstr2 [d];
           a := ord (ch);
           write (bmpfil, a);
           end;

       if Textureindex < 10 then searchstr := 'Tex0000'+tmpstr
       else searchstr := 'Tex000'+tmpstr;

       writeln ('Searching for texture:"',searchstr,'"...');
       if TexSearch (searchstr) then
          begin
          writeln ('Texture uses palette-set #', paletteentry,'  extracting... ');
          {Store texture position, we're going to jump around the OPT now}
          position := filepos (indfil) - 12 + 25;
          {Find palette}
          if paletteoffset[paletteentry] = 0 then
          begin
          SeekPalette;
          paletteoffset [paletteentry] := filepos (indfil);
          end
          else Seek (indfil, paletteoffset[paletteentry]);

          ExtractPalette;

          {Return to stored position of the Texture}
          seek (indfil, position);
          read (indfil, b);
          read (indfil, a);
          x := b + (a*256);
          writeln ('width: ',x);
          seek (bmpfil, 18);
          write (bmpfil, b);
          write (bmpfil, a);

          seek (indfil, filepos (indfil) + 2);
          read (indfil, b);
          read (indfil, a);
          y := b + (a*256);
          writeln ('Height: ',y);
          seek (bmpfil, 22);
          write (bmpfil, b);
          write (bmpfil, a);

          seek (bmpfil, 1078);

          position := filepos (indfil) + 3 + (x*y);
          for bitmaplen := 0 to x * y do
              begin
              seek (indfil, position - bitmaplen);
              read (indfil, d);
              write (bmpfil, d);
              end;
          seek (indfil, position);
          close (bmpfil);
          end
          else
          begin
          GotoXY (1,7);
          writeln ('Progress: 100.0%');
          GotoXY (1,11);
          writeln ('Texture not found, operation completed.');
          writeln ('Done.');
          close (indfil);
          close (bmpfil);
          {Erases the last created BMP file, since the texture wasn't found}
          erase (bmpfil);
          halt;
          end;
   inc (textureindex);
   until eof (indfil);
   end
else
if choice = 1 then Extract2PAL;


close (indfil);
close (bmpfil);
end.